// GMGame.cpp: implementation of the GMGame class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "D3DXApp.h"
#include "GMGame.h"
#include "MainFrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GMGame::GMGame()
{
	m_ground = 0;
	m_players = 1;
	m_selected = 0;
}

GMGame::~GMGame()
{

}

void GMGame::Init(int font, CMainFrame *parent)
{
	m_pParent = parent;

	m_bMenu2  = d3dx.CreateTextureFromRes(AfxGetApp()->m_hInstance, "MENU2");
	m_bAfgan  = d3dx.CreateVirualTexture(m_bMenu2,  1,   2,  72, 66);

	m_bText[0] = d3dx.CreateVirualTexture(font,   20,   92,  186, 30);
	m_bText[1] = d3dx.CreateVirualTexture(font,  168,   45,  130, 40);
	m_bText[2] = d3dx.CreateVirualTexture(font,  303,   92,  207, 30);
	m_bText[3] = d3dx.CreateVirualTexture(font,  311,   53,  136, 30);
}

int GMGame::OnKey(int nChar)
{
	if (nChar == 40) if (++m_selected > 3) m_selected = 0;
	if (nChar == 38) if (--m_selected < 0) m_selected = 3;
	if (nChar == 13)
		switch (m_selected) {
		case 0 :
			m_pParent->m_game.StartGame(m_players, m_ground);
			m_pParent->m_base = &m_pParent->m_game;
			break;
		case 1 : if (++m_players > 4) m_players = 1; break;
		case 2 : if (++m_ground > 2) m_ground = 0; break;
		case 3 : return MENU_MAIN;
		}
	if (nChar == 27) return MENU_MAIN;
	return MENU_DEFAULT;
}

void GMGame::Draw()
{

	for (int i = 0; i < m_players; i++)
		d3dx.Draw(m_bAfgan, 400-((m_players-1)*40)+(i*80), 300, 0, 1, 1, 255, m_ground);

	
	for (i = 0; i < 4; i++) {
		if (i == m_selected)
			d3dx.Draw(m_bText[i], 400, 390+i*50, 0, 1, 1, 255);
		else
			d3dx.Draw(m_bText[i], 400, 390+i*50, 0, 1.25, 1, 128);
	}
}
