// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "D3DXApp.h"

#include "MainFrm.h"
#include "GToplist.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_ERASEBKGND()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_WM_SETCURSOR()
	ON_WM_KILLFOCUS()
	ON_WM_SETFOCUS()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_INITED,  OnInit)
	ON_MESSAGE(WM_GRAPHNOTIFY, OnGraphEvent)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_base = NULL;
}

CMainFrame::~CMainFrame()
{
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


BOOL CMainFrame::OnEraseBkgnd(CDC* pDC) 
{
	CRect rect;
	pDC->GetClipBox(&rect);
	pDC->FillSolidRect(&rect,0);

	return TRUE;
}

void CMainFrame::OnInit(int parama, int paramb)
{
	SetWindowText("Afganci");
	ModifyStyle(WS_SIZEBOX | WS_MAXIMIZEBOX, 0, SWP_DRAWFRAME );

	m_cursor  = AfxGetApp()->LoadCursor(IDC_CURSOR);
	m_acursor = m_cursor;

	InitGame();

	m_menu.Init(this);
	m_game.Init(this);
	m_base = &m_menu;
}

void CMainFrame::OnClose() 
{
	d3dx.Destroy();
	
	CFrameWnd::OnClose();
}

BOOL CMainFrame::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	SetCursor(NULL);
	return TRUE;
}

void CMainFrame::OnKillFocus(CWnd* pNewWnd) 
{
	CFrameWnd::OnKillFocus(pNewWnd);
	hmp3.KillFocus();
}

void CMainFrame::OnSetFocus(CWnd* pOldWnd) 
{
	CFrameWnd::OnSetFocus(pOldWnd);
	hmp3.SetFocus();
}


void CMainFrame::OnTimer(UINT nIDEvent) 
{
	Draw();

	if (GetForegroundWindow() == this)
		Move();

	CFrameWnd::OnTimer(nIDEvent);

}

void CMainFrame::Move()
{
	if (m_base != NULL) m_base->Move();
}

void CMainFrame::Draw()
{
	if (m_base != NULL) m_base->Draw();
	else {
		d3dx.BeginScene();
		d3dx.EndScene();
	}
/*

    D3DGAMMARAMP ddgr;
    WORD dwGamma;

    ZeroMemory( &ddgr, sizeof(ddgr) );


    dwGamma = 0;

    for( int iColor = 0; iColor < 256; iColor++ )
    {
        ddgr.red[iColor]   = dwGamma;
        ddgr.green[iColor] = dwGamma;
        ddgr.blue[iColor]  = dwGamma;

        dwGamma += (WORD) 128;
    }

//    d3dx.m_dev->SetGammaRamp( D3DSGR_NO_CALIBRATION , &ddgr );
    d3dx.m_dev->SetGammaRamp( D3DSGR_CALIBRATE , &ddgr );
	*/  
}

void CMainFrame::OnGraphEvent(int para, int parb)
{
}



void CMainFrame::InitGame()
{
	CD3DXAppApp::InitDirectX();


	SetTimer(0, 25, NULL);
}

void CMainFrame::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if (m_base != NULL) m_base->OnKey(nChar);
	
	CFrameWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CMainFrame::EndGame(int killed)
{
	m_base = &m_menu;
	if (toplist.AddToList(killed)) 
		m_menu.Killed(killed);
}
